package com.flyfish.framework.approval.auditor;

import com.flyfish.framework.approval.domain.ApprovalDomain;
import com.flyfish.framework.approval.enums.ApproveStatus;
import com.flyfish.framework.auditor.ReactiveBeanAuditor;
import org.springframework.stereotype.Component;
import reactor.core.publisher.Mono;

/**
 * 审批拦截审计器
 * 在用户首次提交审核
 *
 * @author wangyu
 */
@Component
public class ApproveAuditor implements ReactiveBeanAuditor<ApprovalDomain> {

    /**
     * 对实体进行审查，并补全相关字段
     *
     * @param data 原数据
     * @return 结果
     */
    @Override
    public Mono<ApprovalDomain> audit(ApprovalDomain data) {
        if (null == data.getApproveStatus()) {
            data.setApproveStatus(ApproveStatus.DRAFT);
        }
        return Mono.just(data);
    }
}
