package com.flyfish.framework.approval.domain;

import com.flyfish.framework.approval.enums.ApproveStatus;
import com.flyfish.framework.domain.base.Vo;
import lombok.Data;

import java.util.Optional;

/**
 * 包装的审批实体
 *
 * @author wangyu
 */
@Data
public abstract class ApprovalDomainVo<T extends ApprovalDomain> implements Vo<T> {

    // 审批状态
    private String approveStatusName;
    // 审批状态编码
    private String approveStatus;
    // 下一审批人
    private String nextApprover;

    @Override
    public Vo<T> from(T po) {
        this.setApproveStatusName(Optional.ofNullable(po.getApproveStatus()).map(ApproveStatus::getName)
                .orElse(ApproveStatus.DRAFT.getName()));
        this.setApproveStatus(Optional.ofNullable(po.getApproveStatus()).map(ApproveStatus::name)
                .orElse(ApproveStatus.DRAFT.name()));
        if (null != po.getNext() && po.getNext() != -1) {
            this.setNextApprover(po.getApprovers().get(po.getNext()));
        }
        return this;
    }
}
