package com.flyfish.framework.backup.domain;

import com.flyfish.framework.domain.base.AuditDomain;
import com.flyfish.framework.enums.NamedEnum;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.Setter;
import org.springframework.data.mongodb.core.mapping.Document;

/**
 * 系统备份
 *
 * @author wangyu
 */
@Getter
@Setter
@Document(collection = "backups")
public class Backup extends AuditDomain {

    // 文件路径
    private String filepath;

    // 备份日志
    private String log;

    // 备份状态
    private Status status;

    // 备份耗时
    private Long period;

    // 备份大小
    private String size;

    /**
     * 备份状态
     */
    @Getter
    @AllArgsConstructor
    public enum Status implements NamedEnum {

        RUNNING("备份中"), SUCCESS("备份成功"), FAILED("备份失败");

        private final String name;
    }
}
