package com.flyfish.framework.domain.tree;

import com.flyfish.framework.builder.CriteriaBuilder;
import com.flyfish.framework.domain.base.Domain;
import com.flyfish.framework.domain.base.NameLikeQo;
import lombok.Getter;
import lombok.Setter;
import org.apache.commons.lang3.BooleanUtils;
import org.springframework.data.mongodb.core.query.Criteria;

import java.util.List;

/**
 * 属性菜单的qo
 */
@Getter
@Setter
public class TreeQo<T extends Domain> extends NameLikeQo<T> {

    private Integer depth;

    private String parentId;

    private List<String> parentIds;

    private Boolean recursive;

    @Override
    public CriteriaBuilder<T> criteriaBuilder() {
        CriteriaBuilder<T> builder = super.criteriaBuilder().with("depth");
        if (BooleanUtils.isTrue(recursive)) {
            builder.with("parentId", "parentIds", Criteria::is)
                    .with("parentIds", "parentIds", CriteriaBuilder.Builders.IN);
        } else {
            builder.with("parentId").with("parentIds", "parentId", CriteriaBuilder.Builders.IN);
        }
        return builder;
    }
}
