package com.flyfish.framework.repository.factory;

import com.flyfish.framework.repository.impl.DefaultRepositoryImpl;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.data.mongodb.repository.support.MongoRepositoryFactory;
import org.springframework.data.repository.core.RepositoryMetadata;
import org.springframework.lang.NonNull;

public class DefaultRepositoryFactory extends MongoRepositoryFactory {

    /**
     * Creates a new {@link MongoRepositoryFactory} with the given {@link MongoOperations}.
     *
     * @param mongoOperations must not be {@literal null}.
     */
    public DefaultRepositoryFactory(MongoOperations mongoOperations) {
        super(mongoOperations);
        this.setRepositoryBaseClass(DefaultRepositoryImpl.class);
    }

    @Override
    @NonNull
    protected Class<?> getRepositoryBaseClass(@NonNull RepositoryMetadata metadata) {
        return DefaultRepositoryImpl.class;
    }
}
